*Section 4: Discrete-time models.
*Creating the person-period file and fitting a logit model.

*READ IN INDIVIDUAL-LEVEL FILE.
get file='c:\fiona\research\EHA briefing paper\examples\files for NCRM website\sect3.sav'.

*OUTPUT FILE IN ASCII FORMAT.
write outfile='tmp1.dat' / age1st (f2.0) event (f1.0) ageleft (f2.0) female (f1.0) reg1 (f1.0) reg2 (f1.0)
  reg3 (f1.0) fclass1 (f1.0) fclass2 (f1.0) id (f3.0).
execute.

*READ AN INDIVIDUAL'S RECORD AND OUTPUT 1 RECORD FOR EACH YEAR FROM AGE=16.
*UNTIL THE AGE THEY PARTNER OR AGE 33 (IF NOT PARTNERED BY THEN). E.G. IF MARRY.
*AT AGE 18 THEN 3 RECORDS ARE OUTPUT FOR AGES 16, 17 AND 18.
input program.
data list file='tmp1.dat' / age1st (f2.0) event (f1.0) ageleft (f2.0) female (f1.0) reg1 (f1.0) reg2 (f1.0)
  reg3 (f1.0) fclass1 (f1.0) fclass2 (f1.0) id (f3.0).
loop t=16 to age1st.
  end case.
  reread.
  data list file='tmp1.dat' / age1st (f2.0) event (f1.0) ageleft (f2.0) female (f1.0) reg1 (f1.0) reg2 (f1.0)
  reg3 (f1.0) fclass1 (f1.0) fclass2 (f1.0) id (f3.0).
end loop.
end input program.
format t (f2.0).

*CREATE THE BINARY DEPENDENT VARIABLE.  FOR YEARS BEFORE PARTNERING/CENSORING.
*Y=0.  FOR THE YEAR AT PARTNERING, Y=1 IF PARTNERED (UNCENSORED) AND Y=0 IF NOT.
*YET PARTNERED (CENSORED).
if (t<age1st) y=0.
if (t=age1st and event=1) y=1.
if (t=age1st and event=2) y=0.
format y (f1.0).

*CREATE TIME-DEPENDENT INDICATOR OF WHETHER OR NOT IN FULL-TIME EDUCATION.
*FULLTIME=1 IF IN FT EDUCATION, AND 0 IF NOT.
if (t<=ageleft) fulltime=1.
if (t>ageleft) fulltime=0.
format fulltime (f1.0).

*CREATE AGE-SQUARED VARIABLE.
compute tsq=t*t.
execute.

*FIT LOGIT MODEL.
LOGISTIC REGRESSION  y
  /METHOD = ENTER t tsq female reg1 reg2 reg3 fclass1 fclass2 fulltime
  /CRITERIA = PIN(.05) POUT(.10) ITERATE(20) CUT(.5) .
