*Section 6: Random effects models for repeated events
*Creating the person-period file and fitting a logit model

cd "c:\fiona\research\EHA briefing paper\examples\files for NCRM website"

*READ IN DISCRETE-TIME DATA FILE
*FOR EACH EPISODE (BIRTH INTERVAL), THERE IS 1 RECORD PER 6-MONTH INTERVAL
use sect6

*FIT STANDARD LOGIT MODEL (I.E. MODEL WITHOUT UNOBSERVED HETEROGENEITY)
logit y mth2 mth3 mth4 mth5 age mardur prev

*FIT RANDOM EFFECTS LOGIT MODEL (I.E. MODEL WITH UNOBSERVED HETEROGENEITY)
*NOTE: SIGMA_U IS THE RANDOM EFFECT STANDARD DEVIATION (NOT THE VARIANCE) 
xtlogit y mth2 mth3 mth4 mth5 age mardur prev, re i(family)

*RESTRUCTURE DATA FOR FITTING RANDOM EFFECTS COX MODEL
*NEED TO COLLAPSE DATA TO 1 RECORD PER EPISODE (INDICATED BY 'ORDER')

*********************************************************************************************************
*NOTE: THIS IS FOR ILLUSTRATION ONLY.  BECAUSE DURATIONS HAVE BEEN GROUPED INTO 6-MTH INTERVALS
*THERE WILL BE A LARGE NUMBER OF TIES (I.E. CONCEPTIONS OCCURING IN THE SAME 6-MTH INTERVAL). IT WOULD 
*HAVE BEEN MUCH BETTER TO MODEL THE DURATIONS IN MONTHS, BUT THIS INFORMATION IS NOT AVAILABLE.
*********************************************************************************************************

bysort family order: gen dur=_n
bysort family order: gen maxdur=_N
keep if dur==maxdur

*SPECIFY DURATION AND CENSORING VARIABLES 
stset dur, failure(y==1)

*FIT STANDARD COX MODEL (I.E. WITHOUT RANDOM EFFECTS)
stcox age mardur prev, nohr

*FIT RANDOM EFFECTS COX MODEL (I.E. WITH SHARED FRAILTY)
stcox age mardur prev, nohr shared(family)

